\noindent The~forwarding engine module has been verified with the~use of simulation tests. The~simulation environment comprises SystemVerilog testbench and classes as well as python scripts responsible for stimulus\footnote{Stimulus is defined as the set of forwarding engine module configuration, forwarding engine requests, \as{tru} module responses, memories' content and expected forwarding engine responses.} generation and forwarding engine reference implementation. The~simulation environment schema is depicted in figure~\ref{fig:simulation-env}.  

The~conducted simulations have confirmed the~estimated performance and the~correct operation of the~developed module for numerous, including boundary, test cases. The~list below contains test scenarios that have been examined:
\begin{enumerate}
	\item forwarding engine processing with highest performance (new requests in every clock cycle),
    \item multiple combinations of \as{htab} entries distribution among sub-tables,
	\item forwarding engine processing disabled,
	\item topology resolution engine disabled,
	\item \textit{pass all} parameter not set for a frame source port,
	\item \textit{pass link local} parameter not set for a frame source port, 
	\item source \as{mac} address not found, learning enabled / disabled,
	\item source \as{mac} address found, \texttt{drop\_when\_src} flag set,
	\item source \as{mac} address found, a frame source port is inconsistent with \texttt{port\_source\_mask} and \texttt{drop\_unmatched\_src} flag set,
	\item destination \as{mac} address not found, broadcasting enabled / disabled,
	\item destination \as{mac} address found, \texttt{drop\_when\_dst} flag set,
	\item multiple combinations of final port mask choice,
	\item multiple combinations of final frame priority choice,
	\item accepting frames with link-local destination \as{mac} address when \textit{pass all} parameter is not set and \textit{pass link local} parameter is set for a frame source port.
\end{enumerate}

\begin{figure}[H]
	\centering
	\includegraphics[scale=1.12]{pic/simulation-env.pdf}
	\caption{The forwarding engine simulation environment.}
	\label{fig:simulation-env}
\end{figure}